<?php

/**
 * Jira Zarafa Plugin
 *
 * Author: Sebastian Gerdes <sebastian.gerdes_AT_catworkx.de>
 *
 */

require_once ('nusoap.php');
require_once('appointmentSOAP.php');

require("/usr/share/php/mapi/mapi.util.php");
require("/usr/share/php/mapi/mapidefs.php");
require("/usr/share/php/mapi/mapicode.php");
require("/usr/share/php/mapi/mapitags.php");
require("/usr/share/php/mapi/mapiguid.php");

define('PR_MY_STARTTIME', mapi_prop_tag(PT_SYSTIME,  0x8516));
define('PR_MY_END', mapi_prop_tag(PT_SYSTIME,  0x820E));


$adminusername = "admin";
$adminpassword = "admin";

$zarafaServer = 'http://192.168.1.123:236/zarafa';

$session = mapi_logon_zarafa($adminusername, $adminpassword, $zarafaServer);

$storetable = mapi_getmsgstorestable($session);
$storeslist = mapi_table_queryallrows($storetable, array(PR_ENTRYID, PR_MDB_PROVIDER));

for ( $i = 0; $i < count($storeslist); $i++)
{
    switch ($storeslist[$i][PR_MDB_PROVIDER])
    {
        case ZARAFA_SERVICE_GUID:
             $defaultstore = mapi_openmsgstore($session, $storeslist[$i][PR_ENTRYID]);
            break;
        case ZARAFA_STORE_PUBLIC_GUID:
            $publicstore = mapi_openmsgstore($session, $storeslist[$i][PR_ENTRYID]);
            break;
    }
}

/**
 * Add a single appointment to the calandar of an user
 */

function addAppointment($username, $subject, $startdate, $body) {
	global $defaultstore, $session;
	
	$properties = array();
            $properties["entryid"] = PR_ENTRYID;
            $properties["body"] = PR_BODY;
            $properties["parent_entryid"] = PR_PARENT_ENTRYID;
            $properties["message_class"] = PR_MESSAGE_CLASS;
            $properties["message_flags"] = PR_MESSAGE_FLAGS;
            $properties["icon_index"] = PR_ICON_INDEX;
            $properties["subject"] = PR_SUBJECT;
            $properties["display_to"] = PR_DISPLAY_TO;
            $properties["importance"] = PR_IMPORTANCE;
            $properties["sensitivity"] = PR_SENSITIVITY;
            $properties["sent_representing_entryid"] = PR_SENT_REPRESENTING_ENTRYID;
            $properties["sent_representing_name"] = PR_SENT_REPRESENTING_NAME;
            $properties["sent_representing_addrtype"] = PR_SENT_REPRESENTING_ADDRTYPE;
            $properties["sent_representing_email_address"] = PR_SENT_REPRESENTING_EMAIL_ADDRESS;
            $properties["sent_representing_search_key"] = PR_SENT_REPRESENTING_SEARCH_KEY;
            $properties["startdate"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x820d";
            $properties["duedate"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x820e";
            $properties["recurring"] ="PT_BOOLEAN:{00062002-0000-0000-C000-000000000046}:0x8223";
            $properties["recurring_data"] =  "PT_BINARY:{00062002-0000-0000-C000-000000000046}:0x8216";
            $properties["recurring_pattern"] = "PT_STRING8:{00062002-0000-0000-C000-000000000046}:0x8232";
            $properties["busystatus"] =  "PT_LONG:{00062002-0000-0000-C000-000000000046}:0x8205";
            $properties["label"] =  "PT_LONG:{00062002-0000-0000-C000-000000000046}:0x8214";
            $properties["alldayevent"] = "PT_BOOLEAN:{00062002-0000-0000-C000-000000000046}:0x8215";
            $properties["private"] = "PT_BOOLEAN:{00062008-0000-0000-C000-000000000046}:0x8506";
            $properties["meeting"] = "PT_LONG:{00062002-0000-0000-C000-000000000046}:0x8217";
            $properties["startdate_recurring"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x8235";
            $properties["enddate_recurring"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x8236";
            $properties["location"] = "PT_STRING8:{00062002-0000-0000-C000-000000000046}:0x8208";
            $properties["duration"] = "PT_LONG:{00062002-0000-0000-C000-000000000046}:0x8213";
            $properties["responsestatus"] =  "PT_LONG:{00062002-0000-0000-C000-000000000046}:0x8218";
            $properties["reminder"] = "PT_BOOLEAN:{00062008-0000-0000-C000-000000000046}:0x8503";
            $properties["reminder_minutes"] = "PT_LONG:{00062008-0000-0000-C000-000000000046}:0x8501";
            $properties["reminder_set"] = "PT_BOOLEAN:{00062008-0000-0000-C000-000000000046}:0x8503";
            $properties["contacts"] = "PT_MV_STRING8:{00062008-0000-0000-C000-000000000046}:0x853a";
            $properties["contacts_string"] = "PT_STRING8:{00062008-0000-0000-C000-000000000046}:0x8586";
            $properties["categories"] = "PT_MV_STRING8:{00020329-0000-0000-C000-000000000046}:Keywords";
            $properties["reminder_time"] = "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8502";
            $properties["flagdueby"] = "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8560";
            $properties["commonstart"] = "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8516";
            $properties["commonend"] = "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8517";
            $properties["basedate"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x8228";
            $properties["timezone_data"] = "PT_BINARY:{00062002-0000-0000-C000-000000000046}:0x8233";
            $properties["commonassign"] = "PT_LONG:{00062008-0000-0000-C000-000000000046}:0x8518";
            $properties["prop8510"] = "PT_LONG:{00062008-0000-0000-C000-000000000046}:0x8510";
            // Conflict properties
            $properties["conflictitems"] = PR_CONFLICT_ITEMS;

            // Propose new time properties
            $properties["proposed_start_whole"] = "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8250";
            $properties["proposed_end_whole"] = "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8251";
            $properties["proposed_duration"] = "PT_LONG:{00062008-0000-0000-C000-000000000046}:0x8256";
            $properties["counter_proposal"] = "PT_BOOLEAN:{00062008-0000-0000-C000-000000000046}:0x8257";

            $properties["deleted_on"] = PR_DELETED_ON;
            $properties["updatecounter"] = "PT_LONG:{00062008-0000-0000-C000-000000000046}:0x8201";
            $properties["isattendee"] = "PT_BOOLEAN:{00062002-0000-0000-C000-000000000046}:0x8229";

	$userlist =  mapi_zarafa_getuserlist($defaultstore);
	if (array_key_exists($username, $userlist)) {
		$store_entryid = mapi_msgstore_createentryid($defaultstore, $username);
		$store = mapi_openmsgstore($session, $store_entryid);
		$properties = getPropIdsFromStrings($store, $properties);
		$rootcontainer = mapi_msgstore_openentry($store);
		if($rootcontainer) {
			$props = mapi_getprops($rootcontainer, array(PR_IPM_APPOINTMENT_ENTRYID));
			if(isset($props[PR_IPM_APPOINTMENT_ENTRYID])) {
				$entryid = $props[PR_IPM_APPOINTMENT_ENTRYID];
				$folder=mapi_msgstore_openentry($store,$entryid);
				$props = array();
				$props[$properties["subject"]] = $subject;
				$props[$properties["message_class"]] = "IPM.Appointment";
				$props[$properties["private"]] = "0";
 				$props[$properties["recurring"]] = "0";
				$props[$properties["icon_index"]] = "1024"; // non recurrent	
				$props[$properties["alldayevent"]] = 1;
				$props[$properties["startdate"]] = $startdate;
				$props[$properties["commonstart"]] = $startdate;
				$props[$properties["commonend"]] = $startdate + 86400;
				$props[$properties["duedate"]] = $startdate + 86400;
				$props[$properties["busystatus"]] = "2";
				$props[$properties["reminder"]] = "0";
				$props[$properties["body"]] = $body;
				$props[$properties["categories"]] = array("Jira");
				$message = mapi_folder_createmessage($folder);
				mapi_setprops($message, $props);
				mapi_savechanges($message);
			}
		}
	}

}


function delAppointment($username, $subject, $startdate) {
	
	global $defaultstore, $session;

	// search the appointment in the calandar of $user and check for same $startdate, $duedate and $subject
	// afterwards delete the message

	$properties = array();
	$properties["entryid"] = PR_ENTRYID; // 268370178
	$properties["subject"] = PR_SUBJECT; // 3604510
	$properties["startdate"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x820d"; // -2146631616
	$properties["duedate"] = "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x820e"; // -2146566080
	
	$userlist = mapi_zarafa_getuserlist($defaultstore);
	if (array_key_exists($username, $userlist)) {
		$store_entryid = mapi_msgstore_createentryid($defaultstore, $username);
		$store = mapi_openmsgstore($session, $store_entryid);
		$rootcontainer = mapi_msgstore_openentry($store);
		if($rootcontainer) {
			$props = mapi_getprops($rootcontainer, array(PR_IPM_APPOINTMENT_ENTRYID));
			if(isset($props[PR_IPM_APPOINTMENT_ENTRYID])) {
				$entryid = $props[PR_IPM_APPOINTMENT_ENTRYID];
				$folder=mapi_msgstore_openentry($store,$entryid);
				if($folder) {
					$table=mapi_folder_getcontentstable($folder);
					$totalrow=mapi_table_getrowcount($table);
					if ($totalrow>0) {
						$restriction = Array(RES_AND,
								Array(Array(RES_PROPERTY,
										Array(RELOP => RELOP_EQ,
											ULPROPTAG => "-2146631616" ,
											VALUE => array("-2146631616" => $startdate))),
									Array(RES_PROPERTY,
										Array(RELOP => RELOP_EQ,
											ULPROPTAG => "-2146566080"  ,
											VALUE => array("-2146566080" => $startdate + 86400))),
									Array(RES_PROPERTY,
										Array(RELOP => RELOP_EQ,
											ULPROPTAG => PR_SUBJECT ,
											VALUE => array(PR_SUBJECT => $subject)))));
						$rows = mapi_table_queryallrows($table, getPropIdsFromStrings($store, $properties), $restriction);
						if (count($rows) == 1) {
							$status = mapi_folder_deletemessages($folder, array($rows[0][268370178]));
						}
					}
				}
			}
		}
	}
}


/**
 * Begin the HTTP listener service and exit.
 */

$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);

?>
