/***************************************************************************
 *   Copyright (C) 2010 by                                                 *
 *                                                                         *
 *   catWorkX GmbH, Schellerdamm 16, 21079 Hamburg                         *
 *   Sebastian Gerdes <sebastian.gerdes_AT_catworkx.de>                    *
 *                                                                         *
 *   This code is part of the Jira2Zarafa Plugin, which is able to add an  *
 *   all-day appointment in Zarafa. This all-day appointment will be added *
 *   when you set a due date and an assignee in a Jira issue.              *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Affero General Public License as        *
 *   published by the Free Software Foundation; either version 3           *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU AFFERO GENERAL PUBLIC LICENSE for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Affero General Public      *
 *   License along with this program.  If not, see                         *
 *   <http://www.gnu.org/licenses/>                                        *
 *                                                                         *
 ***************************************************************************/


package de.catworkx.jira.plugin.zarafa;

public class AppointmentSOAPLocator extends org.apache.axis.client.Service implements de.catworkx.jira.plugin.zarafa.AppointmentSOAP {

    public AppointmentSOAPLocator() {
    }


    public AppointmentSOAPLocator(org.apache.axis.EngineConfiguration config) {
        super(config);
    }

    public AppointmentSOAPLocator(java.lang.String wsdlLoc, javax.xml.namespace.QName sName) throws javax.xml.rpc.ServiceException {
        super(wsdlLoc, sName);
    }

    // Use to get a proxy class for appointmentSOAPPort
    private java.lang.String appointmentSOAPPort_address = "http://192.168.2.209/jira2zarafa/mapiAppointment.php";

    public java.lang.String getappointmentSOAPPortAddress() {
        return appointmentSOAPPort_address;
    }

    // The WSDD service name defaults to the port name.
    private java.lang.String appointmentSOAPPortWSDDServiceName = "appointmentSOAPPort";

    public java.lang.String getappointmentSOAPPortWSDDServiceName() {
        return appointmentSOAPPortWSDDServiceName;
    }

    public void setappointmentSOAPPortWSDDServiceName(java.lang.String name) {
        appointmentSOAPPortWSDDServiceName = name;
    }

    public de.catworkx.jira.plugin.zarafa.AppointmentSOAPPortType getappointmentSOAPPort() throws javax.xml.rpc.ServiceException {
       java.net.URL endpoint;
        try {
            endpoint = new java.net.URL(appointmentSOAPPort_address);
        }
        catch (java.net.MalformedURLException e) {
            throw new javax.xml.rpc.ServiceException(e);
        }
        return getappointmentSOAPPort(endpoint);
    }

    public de.catworkx.jira.plugin.zarafa.AppointmentSOAPPortType getappointmentSOAPPort(java.net.URL portAddress) throws javax.xml.rpc.ServiceException {
        try {
            de.catworkx.jira.plugin.zarafa.AppointmentSOAPBindingStub _stub = new de.catworkx.jira.plugin.zarafa.AppointmentSOAPBindingStub(portAddress, this);
            _stub.setPortName(getappointmentSOAPPortWSDDServiceName());
            return _stub;
        }
        catch (org.apache.axis.AxisFault e) {
            return null;
        }
    }

    public void setappointmentSOAPPortEndpointAddress(java.lang.String address) {
        appointmentSOAPPort_address = address;
    }

    /**
     * For the given interface, get the stub implementation.
     * If this service has no port for the given interface,
     * then ServiceException is thrown.
     */
    public java.rmi.Remote getPort(Class serviceEndpointInterface) throws javax.xml.rpc.ServiceException {
        try {
            if (de.catworkx.jira.plugin.zarafa.AppointmentSOAPPortType.class.isAssignableFrom(serviceEndpointInterface)) {
                de.catworkx.jira.plugin.zarafa.AppointmentSOAPBindingStub _stub = new de.catworkx.jira.plugin.zarafa.AppointmentSOAPBindingStub(new java.net.URL(appointmentSOAPPort_address), this);
                _stub.setPortName(getappointmentSOAPPortWSDDServiceName());
                return _stub;
            }
        }
        catch (java.lang.Throwable t) {
            throw new javax.xml.rpc.ServiceException(t);
        }
        throw new javax.xml.rpc.ServiceException("There is no stub implementation for the interface:  " + (serviceEndpointInterface == null ? "null" : serviceEndpointInterface.getName()));
    }

    /**
     * For the given interface, get the stub implementation.
     * If this service has no port for the given interface,
     * then ServiceException is thrown.
     */
    public java.rmi.Remote getPort(javax.xml.namespace.QName portName, Class serviceEndpointInterface) throws javax.xml.rpc.ServiceException {
        if (portName == null) {
            return getPort(serviceEndpointInterface);
        }
        java.lang.String inputPortName = portName.getLocalPart();
        if ("appointmentSOAPPort".equals(inputPortName)) {
            return getappointmentSOAPPort();
        }
        else  {
            java.rmi.Remote _stub = getPort(serviceEndpointInterface);
            ((org.apache.axis.client.Stub) _stub).setPortName(portName);
            return _stub;
        }
    }

    public javax.xml.namespace.QName getServiceName() {
        return new javax.xml.namespace.QName("http://localhost/appointmentsoap", "appointmentSOAP");
    }

    private java.util.HashSet ports = null;

    public java.util.Iterator getPorts() {
        if (ports == null) {
            ports = new java.util.HashSet();
            ports.add(new javax.xml.namespace.QName("http://localhost/appointmentsoap", "appointmentSOAPPort"));
        }
        return ports.iterator();
    }

    /**
    * Set the endpoint address for the specified port name.
    */
    public void setEndpointAddress(java.lang.String portName, java.lang.String address) throws javax.xml.rpc.ServiceException {
        
if ("appointmentSOAPPort".equals(portName)) {
            setappointmentSOAPPortEndpointAddress(address);
        }
        else 
{ // Unknown Port Name
            throw new javax.xml.rpc.ServiceException(" Cannot set Endpoint Address for Unknown Port" + portName);
        }
    }

    /**
    * Set the endpoint address for the specified port name.
    */
    public void setEndpointAddress(javax.xml.namespace.QName portName, java.lang.String address) throws javax.xml.rpc.ServiceException {
        setEndpointAddress(portName.getLocalPart(), address);
    }

}
